# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%define section free

Name:           mojo-maven-hibernate3
Version:        2.2
Release:        1%{?dist}
Epoch:          0
Summary:        Hibernate 3 Maven 2 Integration
License:        ASL 2.0
Group:          Development/Java
URL:            http://www.jboss.org/
# svn -q export https://svn.codehaus.org/mojo/tags/maven-hibernate3-2.2 mojo-maven-hibernate3-2.2
Source0:        mojo-maven-hibernate3-2.2.tar.bz2
Source1:        mojo-maven-hibernate3-jpp-depmap.xml
Source2:        mojo-maven-hibernate3-settings.xml
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
#hibernate3-maven-plugin
#
BuildRequires:  mojo-parent
BuildRequires:  hsqldb
BuildRequires:  log4j
BuildRequires:  maven-model
BuildRequires:  maven2
BuildRequires:  maven-shared-plugin-testing-harness
#maven-hibernate3-api
BuildRequires:  plexus-utils
BuildRequires:  hibernate3-ejb-persistence-3.0-api
BuildRequires:  hibernate3
#
BuildRequires:  hibernate3-annotations
BuildRequires:  hibernate3-entitymanager
BuildRequires:  jboss-common-core
BuildRequires:  jboss-parent
#
BuildRequires:  hibernate3-tools
#hibernate-tools
#
#maven-hibernate3-api
BuildRequires:  junit
BuildRequires:  geronimo-jta-1.0.1B-api
BuildRequires:  maven2
BuildRequires:  plexus-utils
BuildRequires:  hibernate3
#hibernate-tools
BuildRequires:  slf4j
BuildRequires:  xml-commons-jaxp-1.3-apis
#
#maven-hibernate3-components/pom.xml
#org.codehaus.mojo.hibernate3:maven-hibernate3-api
#
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-ear
BuildRequires:  maven2-plugin-ejb
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Hibernate 3 Maven 2 Integration.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%if %with zips
%package zip
Summary:        Zips for %{name}
Group:          Development/Libraries/Java

%description zip
Zips for %{name}.
%endif

%prep
%setup -q 

%{__cp} -p %{SOURCE2} maven2-settings.xml

%{__sed} -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

%{__mkdir_p} external_repo
%{__ln_s} %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        install

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Daggregate=true \
        javadoc:javadoc

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
%{__cp} -p hibernate3-maven-plugin/target/hibernate3-maven-plugin-%{version}.jar %{buildroot}%{_javadir}/%{name}/hibernate3-maven-plugin-%{version}.jar
%{__cp} -p maven-hibernate3-api/target/maven-hibernate3-api-%{version}.jar %{buildroot}%{_javadir}/%{name}/maven-hibernate3-api-%{version}.jar
%{__cp} -p maven-hibernate3-components/maven-hibernate3-jdk14/target/maven-hibernate3-jdk14-%{version}.jar %{buildroot}%{_javadir}/%{name}/maven-hibernate3-jdk14-%{version}.jar
%{__cp} -p maven-hibernate3-components/maven-hibernate3-jdk15/target/maven-hibernate3-jdk15-%{version}.jar %{buildroot}%{_javadir}/%{name}/maven-hibernate3-jdk15-%{version}.jar
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{version}||g"`; done)

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-maven-hibernate3.pom
%add_to_maven_depmap org.codehaus.mojo.hibernate3 maven-hibernate3 %{version} JPP/%{name} maven-hibernate3
%{__cp} -p hibernate3-maven-plugin/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-hibernate3-maven-plugin.pom
%add_to_maven_depmap org.codehaus.mojo hibernate3-maven-plugin %{version} JPP/%{name} hibernate3-maven-plugin
%{__cp} -p maven-hibernate3-api/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-maven-hibernate3-api.pom
%add_to_maven_depmap org.codehaus.mojo maven-hibernate3-api %{version} JPP/%{name} maven-hibernate3-api
%{__cp} -p maven-hibernate3-components/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-maven-hibernate3-components.pom
%add_to_maven_depmap org.codehaus.mojo maven-hibernate3-components %{version} JPP/%{name} maven-hibernate3-components
%{__cp} -p maven-hibernate3-components/maven-hibernate3-jdk14/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-maven-hibernate3-jdk14.pom
%add_to_maven_depmap org.codehaus.mojo maven-hibernate3-jdk14 %{version} JPP/%{name} maven-hibernate3-jdk14
%{__cp} -p maven-hibernate3-components/maven-hibernate3-jdk15/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-maven-hibernate3-jdk15.pom
%add_to_maven_depmap org.codehaus.mojo maven-hibernate3-jdk15 %{version} JPP/%{name} maven-hibernate3-jdk15

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/hibernate3-maven-plugin-2.2.jar
%{_javadir}/%{name}/hibernate3-maven-plugin.jar
%{_javadir}/%{name}/maven-hibernate3-api-2.2.jar
%{_javadir}/%{name}/maven-hibernate3-api.jar
%{_javadir}/%{name}/maven-hibernate3-jdk14-2.2.jar
%{_javadir}/%{name}/maven-hibernate3-jdk14.jar
%{_javadir}/%{name}/maven-hibernate3-jdk15-2.2.jar
%{_javadir}/%{name}/maven-hibernate3-jdk15.jar
%{_datadir}/maven2/poms/JPP.%{name}-hibernate3-maven-plugin.pom
%{_datadir}/maven2/poms/JPP.%{name}-maven-hibernate3-api.pom
%{_datadir}/maven2/poms/JPP.%{name}-maven-hibernate3-components.pom
%{_datadir}/maven2/poms/JPP.%{name}-maven-hibernate3-jdk14.pom
%{_datadir}/maven2/poms/JPP.%{name}-maven-hibernate3-jdk15.pom
%{_datadir}/maven2/poms/JPP.%{name}-maven-hibernate3.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Mon Sep 13 2010 David Walluck <dwalluck@redhat.com> 0:2.2-1
- release

* Fri Dec 18 2009 David Walluck <dwalluck@redhat.com> 0:2.2-0.1
- release
